//+---------------------------------------------------------------------+
//|                                                       RSIOMA_V2.mq5 | 
//|                                           Copyright  2006, Kalenzo | 
//|                bartlomiej.gorski@gmail.com, http://www.fxservice.eu | 
//+---------------------------------------------------------------------+ 
//|     SmoothAlgorithms.mqh      |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2006, Kalenzo"
#property link "http://www.fxservice.eu"
//---   
#property version   "1.00"
//---     
#property indicator_separate_window
//---    7
#property indicator_buffers 7 
//---    
#property indicator_plots   5
//+----------------------------------------------+
//|           |
//+----------------------------------------------+
//---   1   
#property indicator_type1   DRAW_HISTOGRAM
//---       Teal 
#property indicator_color1  clrTeal
//---    1  2
#property indicator_width1  2
//---    
#property indicator_label1  "Upper"
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//---   2   
#property indicator_type2   DRAW_HISTOGRAM
//---        Red
#property indicator_color2  clrRed
//---    2  2
#property indicator_width2  2
//---    
#property indicator_label2  "Lower"
//+----------------------------------------------+
//|           |
//+----------------------------------------------+
//---   3   
#property indicator_type3   DRAW_ARROW
//---       DeepSkyBlue
#property indicator_color3  clrDeepSkyBlue
//---   3  4
#property indicator_width3  4
//---   
#property indicator_label3  "Buy"
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//---   4   
#property indicator_type4   DRAW_ARROW
//---       Magenta
#property indicator_color4  clrMagenta
//---   4  4
#property indicator_width4  4
//---   
#property indicator_label4  "Sell"
//+----------------------------------------------+
//|     RSIOMA       |
//+----------------------------------------------+
//---      
#property indicator_type5   DRAW_FILLING
//---     
#property indicator_color5  clrLime,clrRed
//---   
#property indicator_label5  "RSIOMA"
//+----------------------------------------------+
//|    CXMA                        |
//+----------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+----------------------------------------------+
//---    CXMA   SmoothAlgorithms.mqh
CXMA XMA1,XMA2;
//---    CMomentum   SmoothAlgorithms.mqh
CMomentum Mom;
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum Applied_price_      //  
  {
   PRICE_CLOSE_ = 1,     // Close
   PRICE_OPEN_,          // Open
   PRICE_HIGH_,          // High
   PRICE_LOW_,           // Low
   PRICE_MEDIAN_,        // Median Price (HL/2)
   PRICE_TYPICAL_,       // Typical Price (HLC/3)
   PRICE_WEIGHTED_,      // Weighted Close (HLCC/4)
   PRICE_SIMPL_,         // Simple Price (OC/2)
   PRICE_QUARTER_,       // Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  // TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_,  // TrendFollow_2 Price
   PRICE_DEMARK_         // Demark Price
  };
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input Smooth_Method RSIOMA_Method=MODE_EMA;   //   RSIOMA
input uint RSIOMA=14;                         //   RSIOMA                    
input int RSIOMAPhase=15;                     //   RSIOMA
//--- RSIOMAPhase:  JJMA    -100 ... +100,     ;
//--- RSIOMAPhase:  VIDIA   CMO,  AMA    
input Smooth_Method MARSIOMA_Method=MODE_EMA; //   MARSIOMA
input uint MARSIOMA=21;                       //   RSIOMA                    
input int MARSIOMAPhase=15;                   //   RSIOMA
//--- MARSIOMAPhase:  JJMA    -100 ... +100,     ;
//--- MARSIOMAPhase:  VIDIA   CMO,  AMA    
input uint MomPeriod=1;                       //  
input Applied_price_ IPC=PRICE_CLOSE;         //  
input uint BuyTrigger=80;                     //  
input uint SellTrigger=20;                    //   
input color BuyTriggerColor=clrDodgerBlue;    //  
input color SellTriggerColor=clrMagenta;      //  
input uint MainTrendLong=60;                  //   
input uint MainTrendShort=40;                 //   
input color MainTrendLongColor=clrGreen;      //   
input color MainTrendShortColor=clrRed;       //   
input int Shift=0;                            //       
//+----------------------------------------------+
//---   ,    
//      
double IndBuffer[],TriggerBuffer[];
double UpBuffer[],DnBuffer[];
double BuyBuffer[],SellBuffer[];
//---      
int min_rates_total,min_rates_1,min_rates_2,min_rates_3;
//+------------------------------------------------------------------+   
//| RSIOMA indicator initialization function                         | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//---     
   min_rates_1=XMA1.GetStartBars(RSIOMA_Method,RSIOMA,RSIOMAPhase);
   min_rates_2=int(min_rates_1+MomPeriod);
   min_rates_3=int(min_rates_2+RSIOMA+1);
   min_rates_total=min_rates_3;
//---       
   XMA1.XMALengthCheck("RSIOMA",RSIOMA);
   XMA1.XMAPhaseCheck("RSIOMAPhase",RSIOMAPhase,RSIOMA_Method);
//---       
   XMA1.XMALengthCheck("MARSIOMA",MARSIOMA);
   XMA1.XMAPhaseCheck("RSIOMAPhase",RSIOMAPhase,MARSIOMA_Method);
//---    IndBuffer   
   SetIndexBuffer(0,UpBuffer,INDICATOR_DATA);
//---    TriggerBuffer   
   SetIndexBuffer(1,DnBuffer,INDICATOR_DATA);
//---    IndBuffer   
   SetIndexBuffer(2,BuyBuffer,INDICATOR_DATA);
//---    TriggerBuffer   
   SetIndexBuffer(3,SellBuffer,INDICATOR_DATA);
//---    IndBuffer   
   SetIndexBuffer(4,IndBuffer,INDICATOR_DATA);
//---    TriggerBuffer   
   SetIndexBuffer(5,TriggerBuffer,INDICATOR_DATA);
//---      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---       Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//---      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---       Shift
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//---      
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---       Shift
   PlotIndexSetInteger(2,PLOT_SHIFT,Shift);
//---       
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---       Shift
   PlotIndexSetInteger(3,PLOT_SHIFT,Shift);
//---       
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,min_rates_total);
//---       Shift
   PlotIndexSetInteger(4,PLOT_SHIFT,Shift);
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"RSIOMA");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//---      4   
   IndicatorSetInteger(INDICATOR_LEVELS,4);
//---       
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,BuyTrigger);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,SellTrigger);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,2,MainTrendLong);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,3,MainTrendShort);
//---       
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,0,BuyTriggerColor);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,1,SellTriggerColor);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,2,MainTrendLongColor);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,3,MainTrendShortColor);
//---       -  
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,0,STYLE_DASHDOTDOT);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,1,STYLE_DASHDOTDOT);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,2,STYLE_DASHDOTDOT);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,3,STYLE_DASHDOTDOT);
//---  
  }
//+------------------------------------------------------------------+ 
//| RSIOMA iteration function                                        | 
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(rates_total<min_rates_total) return(0);
//---       
   double price,x1xma,rel,RSI,positive,negative,sump,sumn;
   static double prev_positive,prev_negative;
//---        
   int first,bar;
//---    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=0; //      
      sumn=0.0;
      sump=0.0;
      int end=first+min_rates_3;
      for(bar=first; bar<end && !IsStopped(); bar++)
        {
         price=PriceSeries(IPC,bar,open,low,high,close);
         x1xma=XMA1.XMASeries(0,prev_calculated,rates_total,RSIOMA_Method,RSIOMAPhase,RSIOMA,price,bar,false);
         rel=Mom.MomentumSeries(min_rates_1,prev_calculated,rates_total,MomPeriod,x1xma,bar,false);
         if(bar>=min_rates_2)
           {
            sump+=MathMax(rel,0);
            sumn-=MathMin(rel,0);
           }
        }
      prev_positive=sump/RSIOMA;
      prev_negative=sumn/RSIOMA;
      first+=min_rates_3;
     }
   else first=prev_calculated-1; //      
//---    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      price=PriceSeries(IPC,bar,open,low,high,close);
      x1xma=XMA1.XMASeries(0,prev_calculated,rates_total,RSIOMA_Method,RSIOMAPhase,RSIOMA,price,bar,false);
      rel=Mom.MomentumSeries(min_rates_1,prev_calculated,rates_total,MomPeriod,x1xma,bar,false);

      sump=+MathMax(rel,0);
      sumn=-MathMin(rel,0);

      positive=(prev_positive*(RSIOMA-1)+sump)/RSIOMA;
      negative=(prev_negative*(RSIOMA-1)+sumn)/RSIOMA;

      if(negative) RSI=100.0-100.0/(1+positive/negative);
      else RSI=0.0;

      IndBuffer[bar]=RSI;
      TriggerBuffer[bar]=XMA2.XMASeries(min_rates_3,prev_calculated,rates_total,MARSIOMA_Method,MARSIOMAPhase,MARSIOMA,RSI,bar,false);

      if(bar<rates_total-1)
        {
         prev_positive=positive;
         prev_negative=negative;
        }

      UpBuffer[bar]=EMPTY_VALUE;
      DnBuffer[bar]=EMPTY_VALUE;
      BuyBuffer[bar]=EMPTY_VALUE;
      SellBuffer[bar]=EMPTY_VALUE;

      if(RSI>MainTrendLong) UpBuffer[bar]=-10;
      if(RSI<MainTrendShort) DnBuffer[bar]=-10;
      if(RSI<SellTrigger && RSI>IndBuffer[bar-1]) BuyBuffer[bar]=-15;
      if(RSI>BuyTrigger && RSI<IndBuffer[bar-1]) SellBuffer[bar]=-15;
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
